
 Unit MASTER;
 Interface
 Uses CRT,Graph,Balls;
  Type
        mainTYPE = array[1..8,1..8] of byte;
 Const
        UkColor = 11;
        xs = 40;
        ys = 27;
        col = 3;
        sht = 5;
 Var Score, d,m,i,j : integer;
      M3      : mainTYPE;
      Strok   : string;
 Procedure Move(var x,y:integer;Var p:pointer;st,st1:byte;var ch:char;var i,j:byte;var colour :byte);
 Procedure BallSh(x,y:integer;Cm:Cc);
 Procedure ShowAll;
 Procedure ShowField;
 Function  PutBalls:boolean;
 Procedure ShowScore(Score:integer);
 Procedure Part(x,y,l,h:integer);
 Procedure CloseSh(x,y:byte);
 Procedure UnPart(i,j:byte);
 Procedure SePart(i,j:byte);
 Implementation
 Procedure Move;
 var u:string;
     qw,wq:byte;
 Begin
  Repeat
   ch:=Readkey;
   PutImage(x,y,p^,0);
   case ch of
      #75: if x>110   then x:=x-st;
      #77: if x<360 then x:=x+st;
      #72: if y>50   then y:=y-st1;
      #80: if y<241 then y:=y+st1;
   end;
   GetImage(x,y,x+7,y+7,p^);
   SetColor(UkColor);
   OutTextXY(x,y,'');
  Until (ch=#13)or(ch=#27);
  if ((x div (xs+2))>0)and((x div (xs+2))<9) then i:=x div (xs+2);
  if ((y div (ys+2))>0)and((y div (ys+2))<9) then j:=y div (ys+2);
  colour:=M3[i,j];
 End;
 Procedure Part;
 Begin
  SetColor(White);
  line(x,y,x+l,y);
  line(x,y,x,y+h);
  setColor(DarkGray);
  line(x,y+h,x+l,y+h);
  line(x+l,y,x+l,y+h);
 End; { Part }
 Procedure ShowScore;
 Begin
  SetFillStyle(1,7);
  Bar(466,80,600,93);
  SetColor(11);
  Str(Score,Strok);
  Strok:='SCORE : '+Strok;
  OutTextXY(470,84,Strok);
 End; { ShowScore }

 Procedure BallSh;
 Var  i,j,c : byte;
 Begin
  for i:=1 to Bx do
   for j:=1 to By do
    begin
     if Ball[j,i]=1 then c:=Cm[1];
     if Ball[j,i]=2 then c:=Cm[2];
     if Ball[j,i]=3 then c:=Cm[3];
     if Ball[j,i]=0 then c:=0{lightgray};
     PutPixel(i+(xs+2)*y+2,j+(ys+2)*x+1,c);
    end;
 End;
 Procedure ShowAll;
 Var i,j : byte;
 Begin
    for i:=1 to 8 do
     for j:=1 to 8 do
        case M3[i,j] of
        0: CloseSh(i,j);
        1: BallSh(j,i,Gc);
        2: BallSh(j,i,Bc);
        3: BallSh(j,i,Rc);
        end;
     ShowScore(Score);
 end;
 Procedure ShowField;
 var i,j : integer;
 begin
  Part(xs-4,ys-3,345,239);
  Part(xs-1,ys-1,340,235);
  Part(417 ,ys-3,190,72);
  Part(420,ys-1,184,50);
  Part(420,79,184,15);
  Part(417,125,190,19);
  Part(420,127,184,15);
   SetColor(12);
   OutTextXY(452,132,'Esc');
   SetColor(11);
   OutTextXY(540,132,'Quit');
  Part(417,175,190,88);
  Part(420,177,184,84);
   SetColor(11);
   OutTextXY(465,185,'INFORMATION');
   SetColor(10);
   OutTextXY(444,200,'Make  lines   from');
   OutTextXY(444,210,' balls  and  they');
   OutTextXY(444,220,' will be destroed.');
   OutTextXY(444,240,'   Ilya Inc ''');
   SetColor(12);
   OutTextXY(444,240,'             98');
 for i:=1 to 8 do
 for j:=1 to 8 do
  Part(i*xs+i*2,j*ys+j*2,xs,ys);
  SetColor(9);
  SetTextStyle(4,horizdir,4);
  OutTextXY(435,30,'Color Balls');
  SetTextStyle(0,horizdir,1);
 end;
 Function PutBalls : boolean;
 Var k,h : byte;
 Begin
      k:=0; i:=1; j:=1;
      Repeat
       if M3[i,j]=0 then k:=k+1;
       i:=i+1;
       if i=9 then begin i:=1; j:=j+1 end;
      Until (k=col) or ((i=8)and(j=8));
   if k<col then begin PutBalls:=False ; Exit end;
   i:=0;

   Repeat
      k:=Random(8)+1; h:=Random(8)+1;
      if M3[k,h]=0 then
      begin
        M3[k,h]:=Random(3)+1;
        if M3[k,h]=1 then BallSh(h,k,Gc);
        if M3[k,h]=2 then BallSh(h,k,Bc);
        if M3[k,h]=3 then BallSh(h,k,Rc);
        i:=i+1;
      end;
   Until i=col;
   PutBalls:=True;
 End;
 Procedure CloseSh;
 Var i,j : byte;
 Begin
   for i:=1 to Bx do
    for j:=1 to By do
       PutPixel(i+(xs+2)*x+2,j+(ys+2)*y+1,7);
 End;
 Procedure UnPart;
 Begin
  SetColor(DarkGray);
  line(i*xs+i*2,j*ys+j*2,i*xs+i*2+xs,j*ys+j*2);
  line(i*xs+i*2,j*ys+j*2,i*xs+i*2,j*ys+j*2+ys);
  setColor(White);
  line(i*xs+i*2,j*ys+j*2+ys,i*xs+i*2+xs,j*ys+j*2+ys);
  line(i*xs+i*2+xs,j*ys+j*2,i*xs+i*2+xs,j*ys+j*2+ys);
 End;
 Procedure SePart;
 Begin
  SetColor(White);
  line(i*xs+i*2,j*ys+j*2,i*xs+i*2+xs,j*ys+j*2);
  line(i*xs+i*2,j*ys+j*2,i*xs+i*2,j*ys+j*2+ys);
  setColor(DarkGray);
  line(i*xs+i*2,j*ys+j*2+ys,i*xs+i*2+xs,j*ys+j*2+ys);
  line(i*xs+i*2+xs,j*ys+j*2,i*xs+i*2+xs,j*ys+j*2+ys);
 End;

 END.
